From 1dc271a428d17d31f9abe196b64d665b5e5579c8 Mon Sep 17 00:00:00 2001
From: Jan Lukas Gernert <jangernert@gmail.com>
Date: Mon, 10 Apr 2023 09:49:02 +0000
Subject: [PATCH] webkitgtk-6.0

---
 .gitlab-ci.yml                       |    2 +-
 Cargo.lock                           | 1470 +++++++++++++++-----------
 Cargo.toml                           |   12 +-
 build-aux/com.gitlab.newsflash.json  |    2 +-
 meson.build                          |    2 +-
 src/app.rs                           |   18 +-
 src/article_view/mod.rs              |  132 ++-
 src/login_screen/web_login.rs        |    6 +-
 src/settings/dialog/theme_chooser.rs |    2 +-
 src/share/share_popover.rs           |   11 +-
 src/util/desktop_settings.rs         |   24 +-
 src/util/mercury.rs                  |   19 +-
 12 files changed, 965 insertions(+), 735 deletions(-)

diff --git a/Cargo.toml b/Cargo.toml
index b833ac7..8a2db2c 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -10,28 +10,28 @@ edition = "2018"
 log = "0.4"
 chrono = "0.4"
 url = "2.3"
-rust-embed = { version = "6.4", features = ["debug-embed", "interpolate-folder-path"] }
+rust-embed = { version = "6.6", features = ["debug-embed", "interpolate-folder-path"] }
 thiserror = "1.0"
 eyre = "0.6"
 serde = { version = "1.0", features = ["serde_derive"] }
 serde_json = "1.0"
-pango = { version = "0.16" }
-glib = { version = "0.16", features = ["v2_70"] }
-gio = { version = "0.16", features = ["v2_70"] }
-gtk4 = { version = "0.5", features = ["v4_6"] }
-gsk4 = { version = "0.5", features = ["v4_6"] }
-gdk4 = { version = "0.5", features = ["v4_6"] }
-libadwaita = { version = "0.2", features = [ "v1_2" ] }
-webkit2gtk5 = { version = "0.2", features = ["v2_34"] }
-javascriptcore5-rs = { version = "0.2" }
+pango = { version = "0.17" }
+glib = { version = "0.17", features = ["v2_70"] }
+gio = { version = "0.17", features = ["v2_70"] }
+gtk4 = { version = "0.6", features = ["v4_6"] }
+gsk4 = { version = "0.6", features = ["v4_6"] }
+gdk4 = { version = "0.6", features = ["v4_6"] }
+libadwaita = { version = "0.4", features = [ "v1_2" ] }
+webkit6 = { git = "https://gitlab.gnome.org/JanGernert/webkit6-rs.git", branch = "crates-io" }
+javascriptcore6 = { git = "https://gitlab.gnome.org/JanGernert/webkit6-rs.git", branch = "crates-io" }
 gettext-rs = { version = "0.7", features = ["gettext-system"] }
 log4rs = "1.2"
-dirs = "4.0"
+dirs = "5.0"
 parking_lot = "0.12"
 color-backtrace = "0.5"
 once_cell = "1.16"
 reqwest = { version = "0.11", features = ["json", "rustls-tls", "socks", "gzip", "brotli", "trust-dns"] }
-tokio = { version = "1.23", features = ["macros", "sync"] }
+tokio = { version = "1.28", features = ["macros", "sync"] }
 futures = { version = "0.3", features = ["thread-pool"] }
 futures-util = "0.3"
 num_cpus = "1.14"
@@ -39,10 +39,10 @@ regex = "1.7"
 feedly_api = "0.5"
 news-flash = { git = "https://gitlab.com/news-flash/news_flash.git" }
 # news-flash = { path = "../news_flash_base/" }
-clap = "4.0"
+clap = "4.2"
 diffus = { version = "0.10", features = [ "derive" ] }
 xmltree = "0.10"
 rc-writer = "1.1"
-ashpd = "0.3"
+ashpd = "0.4"
 html2pango = "0.5"
 percent-encoding = "2.2"
diff --git a/meson.build b/meson.build
index b2942b9..f2e5ed0 100644
--- a/meson.build
+++ b/meson.build
@@ -12,7 +12,7 @@ dependency('gio-2.0', version: '>= 2.66')
 dependency('gdk-pixbuf-2.0')
 dependency('gtk4', version: '>= 4.5.0')
 dependency('libadwaita-1', version: '>=1.0.0')
-dependency('webkit2gtk-5.0', version: '>= 2.34.0')
+dependency('webkitgtk-6.0', version: '>= 2.40.0')
 
 cargo = find_program('cargo', required: true)
 gresource = find_program('glib-compile-resources', required: true)
diff --git a/src/app.rs b/src/app.rs
index 8fba4d3..81ffc2a 100644
--- a/src/app.rs
+++ b/src/app.rs
@@ -1,3 +1,4 @@
+use ashpd::desktop::open_uri::OpenFileRequest;
 use gio::SimpleAction;
 use reqwest::Client;
 use std::collections::HashSet;
@@ -10,7 +11,6 @@ use crate::error::NewsFlashGtkError;
 use crate::error_dialog::ErrorDialog;
 use crate::i18n::{i18n, i18n_f};
 use crate::sidebar::FeedListItemID;
-use ashpd::{desktop::open_uri, WindowIdentifier};
 use futures::channel::oneshot::{self, Sender as OneShotSender};
 use futures::executor::{ThreadPool, ThreadPoolBuilder};
 use futures::FutureExt;
@@ -72,7 +72,7 @@ pub enum Action {
     AddAndAssignTag(String, String, ArticleID),
     TagArticle(ArticleID, TagID),
     UntagArticle(ArticleID, TagID),
-    OpenUrlInDefaultBrowser(String),
+    OpenUri(Url, bool),
 }
 
 pub struct AppPrivate {
@@ -589,7 +589,9 @@ impl App {
         let open_uri_action = SimpleAction::new("open-uri-in-browser", Some(&type_));
         open_uri_action.connect_activate(clone!(@weak self as this => @default-panic, move |_action, parameter| {
             if let Some(uri) = parameter.and_then(|p| p.str()) {
-                Util::send(Action::OpenUrlInDefaultBrowser(uri.to_string()));
+                if let Ok(uri) = Url::parse(uri) {
+                    Util::send(Action::OpenUri(uri, false));
+                }
             } else {
                 Util::send(Action::SimpleMessage("open uri: no parameter".into()));
             }
@@ -710,7 +712,7 @@ impl App {
             Action::AddAndAssignTag(color, title, article_id) => self.add_tag(color, title, Some(article_id)),
             Action::TagArticle(article_id, tag_id) => self.tag_article(article_id, tag_id),
             Action::UntagArticle(article_id, tag_id) => self.untag_article(article_id, tag_id),
-            Action::OpenUrlInDefaultBrowser(url) => self.open_url_in_default_browser(&url),
+            Action::OpenUri(url, ask) => self.open_url_in_default_browser(&url, ask),
         }
         glib::Continue(true)
     }
@@ -2585,7 +2587,7 @@ impl App {
 
         if let (Some(article_model), _article_enclosures) = article_model {
             if let Some(url) = article_model.url {
-                Util::send(Action::OpenUrlInDefaultBrowser(url.to_string()));
+                Util::send(Action::OpenUri(url, false));
             } else {
                 warn!("Open selected article in browser: No url available.")
             }
@@ -2598,18 +2600,18 @@ impl App {
         if let Some(news_flash) = self.imp().news_flash.read().as_ref() {
             if let Ok(article) = news_flash.get_article(article_id) {
                 if let Some(url) = &article.url {
-                    self.open_url_in_default_browser(url.as_str())
+                    self.open_url_in_default_browser(url, false)
                 }
             }
         }
     }
 
-    fn open_url_in_default_browser(&self, url: &str) {
+    fn open_url_in_default_browser(&self, url: &Url, ask: bool) {
         let url = url.to_owned();
 
         let ctx = glib::MainContext::default();
         ctx.spawn_local(async move {
-            if let Err(error) = open_uri::open_uri(&WindowIdentifier::default(), &url, false, false).await {
+            if let Err(error) = OpenFileRequest::default().ask(ask).send_uri(&url).await {
                 Util::send(Action::SimpleMessage(format!("Failed to open URL: {}", error)));
             }
         });
diff --git a/src/article_view/mod.rs b/src/article_view/mod.rs
index 0bdbe4f..7dd19b5 100644
--- a/src/article_view/mod.rs
+++ b/src/article_view/mod.rs
@@ -14,6 +14,7 @@ use eyre::{eyre, Result};
 use futures::channel::oneshot::Sender as OneShotSender;
 use gdk4::{Key, ModifierType, ScrollDirection, ScrollEvent, RGBA};
 use gio::Cancellable;
+use glib::Object;
 use glib::{clone, source::Continue, subclass, MainLoop, SignalHandlerId, SourceId};
 use gtk4::{
     prelude::*, subclass::prelude::*, Box, CompositeTemplate, EventControllerKey, EventControllerMotion,
@@ -21,26 +22,23 @@ use gtk4::{
 };
 use javascriptcore::prelude::*;
 use log::{error, warn};
-use news_flash::models::{Enclosure, FatArticle, Marked, Read};
+use news_flash::models::{Enclosure, FatArticle, Marked, Read, Url};
 use pango::FontDescription;
 use parking_lot::RwLock;
 use rust_embed::RustEmbed;
 use std::str;
 use std::sync::Arc;
 use url::{Host, Origin};
-use webkit2gtk::builders::WebsiteDataManagerBuilder;
-//use webkit2gtk::traits::SettingsExt as WebkitSettingsExt;
-use webkit2gtk::{prelude::*, ContextMenuItem, UserContentInjectedFrames, UserStyleLevel, UserStyleSheet};
-use webkit2gtk::{
-    ContextMenuAction, NavigationPolicyDecision, NetworkProxyMode, NetworkProxySettings, PolicyDecisionType,
-    Settings as WebkitSettings, UserContentFilterStore, WebContext, WebView, WebsiteDataTypes,
+use webkit6::{
+    prelude::*, CacheModel, ContextMenuAction, ContextMenuItem, NavigationPolicyDecision, NetworkProxyMode,
+    NetworkProxySettings, NetworkSession, PolicyDecisionType, Settings as WebkitSettings, UserContentFilterStore,
+    UserContentInjectedFrames, UserStyleLevel, UserStyleSheet, WebContext, WebView, WebsiteDataTypes,
 };
 
 #[derive(RustEmbed)]
 #[folder = "data/resources/article_view"]
 struct ArticleViewResources;
 
-//const MIDDLE_MOUSE_BUTTON: u32 = 2;
 const SCROLL_TRANSITION_DURATION: i64 = 500 * 1000;
 
 #[derive(Clone, Debug)]
@@ -72,6 +70,7 @@ mod imp {
 
         pub view: RwLock<WebView>,
         pub web_context: RwLock<WebContext>,
+        pub network_session: RwLock<NetworkSession>,
 
         #[template_child]
         pub scroll_event: TemplateChild<EventControllerScroll>,
@@ -112,14 +111,7 @@ mod imp {
 
     impl Default for ArticleView {
         fn default() -> Self {
-            let mut data_manager_builder = WebsiteDataManagerBuilder::new();
-            if let Some(webkit_data_dir) = WEBKIT_DATA_DIR.to_str() {
-                data_manager_builder = data_manager_builder
-                    .base_cache_directory(webkit_data_dir)
-                    .base_data_directory(webkit_data_dir);
-            }
-            let data_manager = data_manager_builder.build();
-            let web_context = WebContext::with_website_data_manager(&data_manager);
+            let network_session = NetworkSession::new(WEBKIT_DATA_DIR.to_str(), WEBKIT_DATA_DIR.to_str());
 
             let proxies = App::default().settings().read().get_proxy();
             if !proxies.is_empty() {
@@ -138,10 +130,11 @@ mod imp {
                         }
                     }
                 }
-                web_context.set_network_proxy_settings(NetworkProxyMode::Custom, Some(&mut proxy_settings));
+                network_session.set_proxy_settings(NetworkProxyMode::Custom, Some(&mut proxy_settings));
             }
 
-            web_context.set_cache_model(webkit2gtk::CacheModel::DocumentBrowser);
+            let web_context = WebContext::new();
+            web_context.set_cache_model(CacheModel::DocumentBrowser);
 
             Self {
                 progress_overlay: TemplateChild::default(),
@@ -152,8 +145,9 @@ mod imp {
 
                 load_start_timestamp: RwLock::new(Utc::now()),
 
-                view: RwLock::new(super::ArticleView::new_webview(&web_context)),
+                view: RwLock::new(super::ArticleView::new_webview(&web_context, &network_session)),
                 web_context: RwLock::new(web_context),
+                network_session: RwLock::new(network_session),
 
                 scroll_event: TemplateChild::default(),
                 key_event: TemplateChild::default(),
@@ -302,8 +296,8 @@ impl ArticleView {
         GtkUtil::remove_source(imp.drag_buffer_update_signal.write().take());
         *imp.drag_ongoing.write() = false;
 
-        if let Some(article) = &*imp.visible_article.read() {
-            if let Some(feed_name) = &*imp.visible_feed_name.read() {
+        if let Some(article) = imp.visible_article.read().as_ref() {
+            if let Some(feed_name) = imp.visible_feed_name.read().as_deref() {
                 imp.self_stack.freeze();
                 *imp.load_start_timestamp.write() = Utc::now();
                 let html = self.build_article(&article, feed_name);
@@ -396,7 +390,7 @@ impl ArticleView {
         self.disconnect_view_signals();
 
         // replace webview
-        let new_view = Self::new_webview(&imp.web_context.read());
+        let new_view = Self::new_webview(&imp.web_context.read(), &imp.network_session.read());
         imp.self_stack.set_widget(&new_view);
         *imp.view.write() = new_view;
         self.connect_webview();
@@ -414,11 +408,10 @@ impl ArticleView {
         GtkUtil::disconnect_signal(imp.load_signal.write().take(), &*imp.view.read());
     }
 
-    fn new_webview(ctx: &WebContext) -> WebView {
+    fn new_webview(ctx: &WebContext, session: &NetworkSession) -> WebView {
         let settings = WebkitSettings::new();
         settings.set_enable_html5_database(false);
         settings.set_enable_html5_local_storage(false);
-        settings.set_enable_java(false);
         settings.set_enable_page_cache(false);
         settings.set_enable_smooth_scrolling(true);
         settings.set_enable_javascript(true);
@@ -430,7 +423,10 @@ impl ArticleView {
         let auto_load = App::default().settings().read().get_article_view_load_images();
         settings.set_auto_load_images(auto_load);
 
-        let webview = WebView::with_context(ctx);
+        let webview = Object::builder::<WebView>()
+            .property("network-session", session)
+            .property("web-context", ctx)
+            .build();
         webview.set_settings(&settings);
         Self::load_style_sheet(&webview);
         Self::load_content_filter(&webview);
@@ -680,33 +676,42 @@ impl ArticleView {
                     .read()
                     .connect_decide_policy(move |_closure_webivew, decision, decision_type| {
                         if decision_type == PolicyDecisionType::NewWindowAction {
-                            if let Some(navigation_decision) = decision.downcast_ref::<NavigationPolicyDecision>() {
-                                if let Some(frame_name) = navigation_decision.frame_name() {
-                                    if &frame_name == "_blank" {
-                                        if let Some(action) = navigation_decision.navigation_action() {
-                                            if let Some(uri_req) = action.request() {
-                                                if let Some(uri) = uri_req.uri() {
-                                                    Util::send(Action::OpenUrlInDefaultBrowser(uri.as_str().into()));
-                                                }
-                                            }
-                                        }
-                                    }
+                            let navigation_action = decision
+                                .downcast_ref::<NavigationPolicyDecision>()
+                                .and_then(|descision| descision.navigation_action());
+
+                            if let Some(mut navigation_action) = navigation_action {
+                                let is_blank = navigation_action
+                                    .frame_name()
+                                    .map(|name| name == "_bank")
+                                    .unwrap_or(false);
+                                if is_blank {
+                                    navigation_action
+                                        .request()
+                                        .and_then(|request| request.uri())
+                                        .and_then(|uri| Url::parse(uri.as_str()).ok())
+                                        .map(|uri| Util::send(Action::OpenUri(uri, false)));
                                 }
                             }
                             decision.ignore();
                             return true;
                         } else if decision_type == PolicyDecisionType::NavigationAction {
-                            if let Some(navigation_decision) = decision.downcast_ref::<NavigationPolicyDecision>() {
-                                if let Some(action) = navigation_decision.navigation_action() {
-                                    if let Some(request) = action.request() {
-                                        if let Some(uri) = request.uri() {
-                                            if action.is_user_gesture() {
-                                                decision.ignore();
-                                                Util::send(Action::OpenUrlInDefaultBrowser(uri.as_str().into()));
-                                            }
-                                        }
-                                    }
-                                }
+                            let mut action = decision
+                                .downcast_ref::<NavigationPolicyDecision>()
+                                .and_then(|navigation_decision| navigation_decision.navigation_action());
+                            let is_user_gesture =
+                                action.as_mut().map(|action| action.is_user_gesture()).unwrap_or(false);
+
+                            if is_user_gesture {
+                                action
+                                    .as_mut()
+                                    .and_then(|action| action.request())
+                                    .and_then(|request| request.uri())
+                                    .and_then(|uri| Url::parse(uri.as_str()).ok())
+                                    .map(|uri| {
+                                        decision.ignore();
+                                        Util::send(Action::OpenUri(uri, false));
+                                    });
                             }
                         }
                         false
@@ -751,7 +756,7 @@ impl ArticleView {
             .replace(
                 imp.view
                     .read()
-                    .connect_context_menu(|_closure_webivew, ctx_menu, _event, hit_test| {
+                    .connect_context_menu(|_closure_webivew, ctx_menu, hit_test| {
                         let menu_items = ctx_menu.items();
 
                         for item in menu_items {
@@ -1047,10 +1052,16 @@ impl ArticleView {
 
     fn set_scroll_pos_static(view: &WebView, pos: f64) {
         let cancellable: Option<&Cancellable> = None;
-        view.run_javascript(&format!("window.scrollTo(0,{});", pos), cancellable, |res| match res {
-            Ok(_) => {}
-            Err(_) => error!("Setting scroll pos failed"),
-        });
+        view.evaluate_javascript(
+            &format!("window.scrollTo(0,{});", pos),
+            None,
+            None,
+            cancellable,
+            |res| match res {
+                Ok(_) => {}
+                Err(_) => error!("Setting scroll pos failed"),
+            },
+        );
     }
 
     fn get_scroll_pos_static(view: &WebView) -> f64 {
@@ -1079,14 +1090,15 @@ impl ArticleView {
         let wait_loop = Arc::new(MainLoop::new(None, false));
         let value: Arc<RwLock<Option<f64>>> = Arc::new(RwLock::new(None));
         let cancellable: Option<&Cancellable> = None;
-        view.run_javascript(
+        view.evaluate_javascript(
             java_script,
+            None,
+            None,
             cancellable,
             clone!(@weak wait_loop, @weak value => @default-panic, move |res| {
                 match res {
                     Ok(result) => {
-                        let new_value = result.js_value().expect("Failed to get value from js result.");
-                        *value.write() = Some(new_value.to_double());
+                        *value.write() = Some(result.to_double());
                     }
                     Err(_) => error!("Getting scroll pos failed"),
                 }
@@ -1238,7 +1250,13 @@ impl ArticleView {
 
     pub fn clear_cache(&self, oneshot_sender: OneShotSender<()>) {
         let imp = self.imp();
-        if let Some(data_manager) = imp.web_context.read().website_data_manager() {
+        let data_manager = imp
+            .view
+            .read()
+            .network_session()
+            .and_then(|session| session.website_data_manager());
+
+        if let Some(data_manager) = data_manager {
             let cancellable: Option<&Cancellable> = None;
             data_manager.clear(
                 WebsiteDataTypes::all(),
diff --git a/src/login_screen/web_login.rs b/src/login_screen/web_login.rs
index 8cdf67d..a5e0809 100644
--- a/src/login_screen/web_login.rs
+++ b/src/login_screen/web_login.rs
@@ -11,9 +11,8 @@ use news_flash::error::NewsFlashError;
 use news_flash::models::{ApiSecret, LoginData, LoginGUI, OAuthData, PluginInfo};
 use parking_lot::RwLock;
 use std::sync::Arc;
-use webkit2gtk::traits::WebkitSettingsExt;
-use webkit2gtk::Settings;
-use webkit2gtk::{traits::WebViewExt, LoadEvent, WebView};
+use webkit6::Settings;
+use webkit6::{traits::WebViewExt, LoadEvent, WebView};
 
 mod imp {
     use super::*;
@@ -79,7 +78,6 @@ impl WebLogin {
         let settings = Settings::new();
         settings.set_enable_html5_database(false);
         settings.set_enable_html5_local_storage(false);
-        settings.set_enable_java(false);
         settings.set_enable_page_cache(false);
         settings.set_enable_smooth_scrolling(true);
         settings.set_enable_javascript(true);
diff --git a/src/settings/dialog/theme_chooser.rs b/src/settings/dialog/theme_chooser.rs
index 277bdcb..cfdf8e8 100644
--- a/src/settings/dialog/theme_chooser.rs
+++ b/src/settings/dialog/theme_chooser.rs
@@ -4,7 +4,7 @@ use chrono::Utc;
 use glib::{clone, subclass::*};
 use gtk4::{prelude::*, subclass::prelude::*, CompositeTemplate, GestureClick, ListBox, ListBoxRow, Popover, Widget};
 use news_flash::models::{ArticleID, FatArticle, FeedID, Marked, Read};
-use webkit2gtk::{traits::WebViewExt, WebView};
+use webkit6::{traits::WebViewExt, WebView};
 
 mod imp {
     use super::*;
diff --git a/src/share/share_popover.rs b/src/share/share_popover.rs
index 8edf36d..f186592 100644
--- a/src/share/share_popover.rs
+++ b/src/share/share_popover.rs
@@ -8,6 +8,7 @@ use crate::{
 };
 use glib::{clone, subclass};
 use gtk4::{prelude::*, subclass::prelude::*, CompositeTemplate, ListBox, Popover, Widget};
+use news_flash::models::Url;
 use percent_encoding::{utf8_percent_encode, NON_ALPHANUMERIC};
 
 mod imp {
@@ -148,21 +149,23 @@ impl SharePopover {
 
             let title = article.title.unwrap_or("Unkown Article".into());
 
-            let share_url = Self::prepare_share_url(&url_template, article_url.as_str(), &title);
-            Util::send(Action::OpenUrlInDefaultBrowser(share_url));
-            Util::send(Action::SimpleMessage(format!("Article shared with {}", name)));
+            if let Some(share_url) = Self::prepare_share_url(&url_template, article_url.as_str(), &title) {
+                Util::send(Action::OpenUri(share_url, true));
+                Util::send(Action::SimpleMessage(format!("Article shared with {}", name)));
+            }
             this.popdown();
         }));
 
         imp.list.append(&row);
     }
 
-    fn prepare_share_url(url_template: &str, article_url: &str, title: &str) -> String {
+    fn prepare_share_url(url_template: &str, article_url: &str, title: &str) -> Option<Url> {
         let article_url_escaped = utf8_percent_encode(article_url, NON_ALPHANUMERIC).to_string();
         let title_escaped = utf8_percent_encode(title, NON_ALPHANUMERIC).to_string();
 
         let url = url_template.replace("${url}", &article_url_escaped);
         let url = url.replace("${title}", &title_escaped);
+        let url = Url::parse(&url).ok();
         url
     }
 }
diff --git a/src/util/desktop_settings.rs b/src/util/desktop_settings.rs
index 3af2fa2..db677d0 100644
--- a/src/util/desktop_settings.rs
+++ b/src/util/desktop_settings.rs
@@ -1,6 +1,5 @@
-use ashpd::desktop::settings::SettingsProxy;
-use ashpd::zbus;
-use gio::Settings;
+use ashpd::desktop::settings::Settings;
+use gio::Settings as GSettings;
 use glib::clone;
 use gtk4::prelude::SettingsExt;
 use parking_lot::RwLock;
@@ -42,15 +41,14 @@ impl DesktopSettings {
     }
 
     async fn get_document_font() -> ashpd::Result<String> {
-        if ashpd::is_sandboxed() {
-            let connection = zbus::Connection::session().await?;
-            let proxy = SettingsProxy::new(&connection).await?;
-            let font = proxy
+        if ashpd::is_sandboxed().await {
+            let settings = Settings::new().await?;
+            let font = settings
                 .read::<String>("org.gnome.desktop.interface", "document-font-name")
                 .await?;
             Ok(font)
         } else {
-            Ok(Settings::new("org.gnome.desktop.interface")
+            Ok(GSettings::new("org.gnome.desktop.interface")
                 .string("document-font-name")
                 .as_str()
                 .into())
@@ -58,15 +56,13 @@ impl DesktopSettings {
     }
 
     async fn get_clock_format() -> ashpd::Result<ClockFormat> {
-        let clock_format = if ashpd::is_sandboxed() {
-            let connection = zbus::Connection::session().await?;
-            let proxy = SettingsProxy::new(&connection).await?;
-
-            proxy
+        let clock_format = if ashpd::is_sandboxed().await {
+            let settings = Settings::new().await?;
+            settings
                 .read::<String>("org.gnome.desktop.interface", "clock-format")
                 .await?
         } else {
-            Settings::new("org.gnome.desktop.interface")
+            GSettings::new("org.gnome.desktop.interface")
                 .string("clock-format")
                 .as_str()
                 .into()
diff --git a/src/util/mercury.rs b/src/util/mercury.rs
index 82794bc..2d00855 100644
--- a/src/util/mercury.rs
+++ b/src/util/mercury.rs
@@ -11,7 +11,7 @@ use rust_embed::RustEmbed;
 use serde::{Deserialize, Serialize};
 use std::str;
 use std::sync::Arc;
-use webkit2gtk::{traits::*, Settings, WebView};
+use webkit6::{traits::*, Settings, WebView};
 
 #[derive(RustEmbed)]
 #[folder = "data/resources/mercury"]
@@ -90,7 +90,6 @@ impl MercuryParser {
         let settings = Settings::new();
         settings.set_enable_html5_database(false);
         settings.set_enable_html5_local_storage(false);
-        settings.set_enable_java(false);
         settings.set_enable_page_cache(false);
         settings.set_enable_smooth_scrolling(true);
         settings.set_enable_javascript(true);
@@ -116,18 +115,14 @@ impl MercuryParser {
 
                 if title == "ready" {
                     let cancellable = gio::Cancellable::new();
-                    view.run_javascript("global_result", Some(&cancellable), clone!(@strong js_finished, @weak value => move |result| {
+                    view.evaluate_javascript("global_result", None, None, Some(&cancellable), clone!(@strong js_finished, @weak value => move |result| {
                         match result {
                             Ok(result) => {
-                                if let Some(val) = result.js_value() {
-                                    let string = val.to_str();
-                                    if string.trim().is_empty() {
-                                        log::error!("Empty string: likely a JS error");
-                                    } else {
-                                        *value.write() = string.as_str().to_owned();
-                                    }
+                                let string = result.to_str();
+                                if string.trim().is_empty() {
+                                    log::error!("Empty string: likely a JS error");
                                 } else {
-                                    log::error!("No return value");
+                                    *value.write() = string.as_str().to_owned();
                                 }
                             }
                             Err(error) => log::error!("error: '{}'", error),
@@ -146,7 +141,7 @@ impl MercuryParser {
         }));
 
         let cancellable = gio::Cancellable::new();
-        view.run_javascript(javascript, Some(&cancellable), |_res| {});
+        view.evaluate_javascript(javascript, None, None, Some(&cancellable), |_res| {});
 
         let start_time = Utc::now();
         while js_finished.read().is_none() && (Utc::now() - start_time) < Duration::seconds(10) {
